function s060215_musing_change_detection
  

lighten = inline( '255 * sqrt( im / 255 )', 'im' );
  
  fit_par = [];
  fit_par.verbose = 0;
  fit_par.debug   = 0;

  fit_par.min_iter = 10;
  fit_par.max_iter = 1000;
  
  fit_par.nsamples = 100;
  
  opt = optimset( @fminbnd );
  opt = optimset( opt, 'Display', 'off', 'MaxFunEvals', 40, 'MaxIter', 10, 'TolX', +Inf, 'TolFun', 1e-4 );
  fit_par.fminsearch_options = opt;
  

%

a_dir = '/home/speech/lathoud/2005-10-11-MMM-BACKUP/Lathoud/av16.3_v6/HAI/seq6_iain2_cam1_save';

im1 = Lecture( fullfile( a_dir, 'image00767.ppm' ) );
figure; image( uint8( im1 ) );

im2 = Lecture( fullfile( a_dir, 'image00768.ppm' ) );
figure; image( uint8( im2 ) );

im3 = Lecture( fullfile( a_dir, 'image00769.ppm' ) );
figure; image( uint8( im3 ) );

if 0
  figure; image( uint8( abs( im2-im1 ) ) );
  figure; image( uint8( abs( im3-im2 ) ) );
end

zz = abs( im3-im2 - ( im2-im1 ) );
figure; image( uint8( zz ) );
figure; image( uint8( lighten( zz ) ) );
% figure; hist( zz(:), 100 );
figure; hist( log( zz( find( zz ) ) ), 100 );
figure; image( uint8( 255 * ( zz > exp( 3.65 ) ) ) );

warning off
[ fit_model_r, misc_r ] = fit_1d1g1sr_fast( reshape( zz(:,:,1), [], 1 ), fit_par );
[ fit_model_g, misc_g ] = fit_1d1g1sr_fast( reshape( zz(:,:,2), [], 1 ), fit_par );
[ fit_model_b, misc_b ] = fit_1d1g1sr_fast( reshape( zz(:,:,3), [], 1 ), fit_par );
warning on

log_post = cat( 3, misc_r.log_post( :,:,2 ), misc_g.log_post( :,:,2 ), misc_b.log_post( :,:,2 ) );

log_post = reshape( log_post, size( zz ) );

if 0
  pp = 255 * exp( max( log_post, [], 3 ) );
  figure; image( uint8( pp ) );
end

pp2 = 255 * exp( sum( log_post, 3 ) );
figure; image( uint8( pp2 ) );

% RGBN

if 0
  tmp = max( eps, sum( im1, 3 ) );
  im1n = 255 * im1 ./ repmat( tmp, [ 1 1 3 ] );
  
  tmp = max( eps, sum( im2, 3 ) );
  im2n = 255 * im2 ./ repmat( tmp, [ 1 1 3 ] );
  
  tmp = max( eps, sum( im3, 3 ) );
  im3n = 255 * im3 ./ repmat( tmp, [ 1 1 3 ] );
  
  figure; image( uint8( im1n ) );
  figure; image( uint8( im2n ) );
  figure; image( uint8( im3n ) );

  figure; image( uint8( abs( rgb2rgbn( im2 ) - rgb2rgbn( im1 ) ) ));

end

d21 = im2 - im1;
d32 = im3 - im2;
dd321 = d32 - d21;

if 0
  figure; image( uint8( abs( d21 ) ) );
  figure; image( uint8( lighten( abs( d21 ) ) ) );
  
  figure; image( uint8( abs( d32 ) ) );
  figure; image( uint8( lighten( abs( d32 ) ) ) );
  
  figure; image( uint8( abs( dd321 ) ) );
  figure; image( uint8( lighten( abs( dd321 ) ) ) );
end

% This one may be interesting
oo = sqrt( abs( d21 ) .* abs( d32 ) );
figure; image( uint8( oo ) );
figure; image( uint8( lighten( oo ) ) );

% Histogram on each channel R,G,B
figure; hist( reshape( oo( :, :, 1 ), [], 1 ), 100 );
figure; hist( reshape( oo( :, :, 2 ), [], 1 ), 100 );
figure; hist( reshape( oo( :, :, 3 ), [], 1 ), 100 );

for a = 1:3
  v =  reshape(  oo( :, :, a ), [], 1 );
  figure; hist( log( v( find( v > 0 ) ) ), 100 );
end

figure; image(uint8(255 * ( oo > 20 ) ) );


v1 =  reshape(  oo( :, :, 1 ), [], 1 );
v2 =  reshape(  oo( :, :, 2 ), [], 1 );
v3 =  reshape(  oo( :, :, 3 ), [], 1 );

figure; loglog( v1, v2, '.' );
figure; loglog( v1, v3, '.' );
figure; loglog( v2, v3, '.' );

if 0
  pp = sqrt( oo .* im2 );
  figure; image( uint8( pp ) );
  figure; image( uint8( lighten( pp ) ) );
  
  % Histogram on each channel R,G,B
  figure; hist( reshape( pp( :, :, 1 ), [], 1 ), 100 );
  figure; hist( reshape( pp( :, :, 2 ), [], 1 ), 100 );
  figure; hist( reshape( pp( :, :, 3 ), [], 1 ), 100 );
  
  figure; image(uint8(255 * ( pp > 45 ) ) );
end

if 0 
  qq = sqrt( abs( dd321 ) .* sqrt( abs( d21 ) .* abs( d32 ) ) );
  figure; image( uint8( qq ) );
  figure; image( uint8( lighten( qq ) ) );
end

if 0 
  figure; image( uint8( rgb2rgbn( im1 ) ) );
  
  figure; image( uint8( abs( rgb2rgbn( d21 ) ) ) );
  figure; image( uint8( abs( rgb2rgbn( d32 ) ) ) );
  figure; image( uint8( abs( rgb2rgbn( dd321 ) ) ) );
  
  u = abs( rgb2rgbn( d21 ) );
  v = abs( rgb2rgbn( d32 ) );
  
  figure; image( uint8( sqrt( u .* v ) ) );
  figure; image( uint8( 255 * sqrt( sqrt( u .* v ) / 255 ) ) );
end


keyboard