function s060307_fit_audio_model( input_ssm_result_filename, output_model_filename )
  
  if nargin < 2
    
    error( [ mfilename ' needs two input arguments.' ] );
  
  end
  
  % Load audio features
  
  load( input_ssm_result_filename, 'ssm_result' );
  
  % Fit silence/activity model
  
  a_par = [];
  
  a_par.summary_min_iter = 10;
  a_par.summary_max_iter = 100;
  a_par.summary_lkld_conv = 1e-5;
  
  a_par.fulldata_min_iter = 5;
  a_par.fulldata_max_iter = 10;
  a_par.fulldata_lkld_conv = 1e-5;
  
  model_2d2g1sr = fit_2d2g1sr( ssm_result.activeness, a_par );
  
  % Write out
  
  base_audio_filename = input_ssm_result_filename;
  
  save( output_model_filename, 'model_2d2g1sr', 'base_audio_filename' );
  
  disp( [ mfilename ' wrote out model file "' output_model_filename '".' ] );
  